
ToolBoxFile "StringBetween - Module.pb", "DownloadToString - Module.pb"

; Diese beiden Variablen bitte selber den eigenen wnschen nach anpassen!
; Please adapt these two variables to your own wishes!
; //
Global HighScoreKey$ = "Password"
Global HighScoreURL$ = "http://gsaumure.x10host.com/speedtetris/HighScore.php"
; \\

InitNetwork()


; Ldt den Inhalt einer URL in einen String
; Loads the contents of a URL into a string



; Strukture der HighScore
; The Highscore structure

Structure HighScore
  Points.l
  TotalTime.q
  Name$
EndStructure

Global NewList HighScore.HighScore()


; Fgt einen Eintrag in die Internet HighScore
; Adds an entry to the Internet HighScore

Procedure AddHighScoreItem(Points.l, TotalTime.q, Name$)
  Protected Points$ = Str(Points)
  Protected TotalTime$ = Str(TotalTime)
  
  Name$ = URLEncoder(Name$)
  
  Protected Get$ = "?Points=" + Points$ + "&TotalTime=" + TotalTime$ + "&Name=" + Name$ + "&Key=" + DESFingerprint(Points$ + TotalTime$ + Name$, HighScoreKey$)
  
  String$ = DownloadToString::DoIt(HighScoreURL$ + Get$)
  If String$
    If String$ = "TRUE"
      Debug "High score entry added."
      ProcedureReturn #True
    ElseIf String$ = "FALSE #1"
      Debug "Invalid entry!"
    ElseIf String$ = "FALSE #2"
      Debug "Error when entering (or write to the file)!"
    ElseIf String$ = "FALSE #3"
      Debug "Identical entry!"
    Else
      Debug "Unknown error!"
      Debug String$   
    EndIf
  Else
    Debug "Download failed!" 
  EndIf 
  
EndProcedure


; Ldt die Internet HighScore runter
;  Dabei kann ab einem bestimmten Platz (Start)
;  eine bestimmte Menge (Count) runtergeladen werden.
Procedure ExamineHighScore(Start=1, Count=0)
  
  Protected Get$, Position, OldPosition, Item$
  ClearList(HighScore())
  
  If Count > 0
    Get$ = "?from=" + Str(Start) + "&to=" + Str(Start+Count)
  Else
    Get$ = "?from=" + Str(Start)
  EndIf
  
  String$ = DownloadToString::DoIt(HighScoreURL$ + Get$)

  If String$
    
    Repeat
      Position = FindString(String$, Chr(13), OldPosition+1)
      If Position
        Item$ = StringBetween::FindIt(Mid(String$, OldPosition+1, Position-OldPosition-1), "(", ")") 
        AddElement(HighScore())
        HighScore()\Points = Val(StringField(Item$, 1, ", "))
        HighScore()\TotalTime = Val(StringField(Item$, 2, ", "))
        HighScore()\Name$ = RemoveString(StringField(Item$, 3, ", "), Chr(34))
        OldPosition = Position
      EndIf
      
    Until Not Position
    
    ResetList(HighScore())
    
    ProcedureReturn #True
    
  Else
    Debug "Download failed!" 
  EndIf
  
EndProcedure

; Springt zum nchsten HighScore Eintrag (der Download-HighScore)
; Jump To the Next high score entry (the download high score)

Macro NextHighScoreItem()
  NextElement(HighScore())
EndMacro

; Gibt die Punkte des HighScore Eintrags zurck
; Returns the points of the high score entry

Macro GetHighScorePoints()
  HighScore()\Points
EndMacro

Macro GetHighScoreTotalTime()
  HighScore()\TotalTime
EndMacro

; Gibt den Namen des HighScore Eintrags zurck
; Returns the name of the high score entry

Macro GetHighScoreName()
  HighScore()\Name$
EndMacro


; Debug AddHighScoreItem(5000, 12500, "GUILLAUME")
; Delay(5000)
; Debug AddHighScoreItem(4990, 13500, "GUILLAUME")
; Delay(5000)
; Debug AddHighScoreItem(4850, 14500, "GUILLAUME")
; Delay(5000)
; Debug AddHighScoreItem(4995, 15500, "GUILLAUME")
; Delay(5000)

If ExamineHighScore()
  
  While NextHighScoreItem()
    Debug GetHighScorePoints()
    Debug GetHighScoreTotalTime()
    Debug GetHighScoreName()
    Debug ""
  Wend
  
EndIf






; IDE Options = PureBasic 5.71 beta 1 LTS (Linux - x64)
; Folding = --
; EnableXP
; CompileSourceDirectory